<?php

App::uses('AppBehavior', 'Model/Behavior');

class TaxableBehavior extends AppBehavior {

	/**
	 * link the model that has this behavior with the tax levels model
	 * so we can contain data
	 */
	protected function _linkModels(Model $Model) {
		$Model->bindModel(
			array(
				'belongsTo' => array(
					'TaxLevel' => array(
						'className' => 'EvTax.TaxLevel'
					)
				)
			),
			false
		);
	}

	/**
	 * get tax rate
	 *
	 * @param 	Model 			Model object auto populated by CakeORM
	 * @param 	int 			item ID
	 * @return 	decimal|bool 	Tax Rate or bool false if not found
	 */
	public function getTaxRate($Model, $itemId) {
		$this->_linkModels($Model);

		$data = $Model->find(
			'first',
			array(
				'conditions' => array(
					$Model->alias . '.id' => $itemId
				),
				'contain' => array(
					'TaxLevel'
				)
			)
		);

		if (isset($data['TaxLevel']) && array_key_exists('rate', $data['TaxLevel'])) {
			return $data['TaxLevel']['rate'];
		}

		return false;
	}
}
